#ifndef WA_EXIT_CODE
#   ifdef EJUDGE
#       define WA_EXIT_CODE 5
#   else
#       define WA_EXIT_CODE 1
#   endif
#endif

#ifndef PE_EXIT_CODE
#   ifdef EJUDGE
#       define PE_EXIT_CODE 5
#   else
#       define PE_EXIT_CODE 1
#   endif
#endif

#include "testlib.h"

using namespace std;

void skipSpacesBeforeEoln() {
    if (!ouf.seekEoln()) {
        quit(_wa, "Expected end of line");
    }
}

int main(int argc, char *argv[]) {
    setName("check settlement");
    registerTestlibCmd(argc, argv);
    int blocks = inf.readInt();
    int boys = inf.readInt();
    int girls = inf.readInt();

    string answer = upperCase(ouf.readWord());
    string juryAnswer = upperCase(ans.readWord());
    bool participantCan = answer == "YES";
    bool juryCan = juryAnswer == "YES";
    if (!participantCan) {
        if (juryCan) {
            quitf(_wa, "actually, settlement exists");
        } else {
            quit(_ok, "settlement doesn't exist");
        }
    }

    int roomsTotal = blocks * 2;
    vector<int> roomsBoys(roomsTotal);
    vector<int> roomsGirls(roomsTotal);
    skipSpacesBeforeEoln();
    for (int i = 0; i < boys + girls; i++) {
        if (i == boys) {
            skipSpacesBeforeEoln();
        }
        int room = ouf.readInt() - 1;
        if (room < 0 || roomsTotal <= room) {
            quitf(_wa, "room #%d does not exist", room + 1);
        }
        if (i < boys) {
            roomsBoys[room]++;
        } else {
            roomsGirls[room]++;
        }
    }
    skipSpacesBeforeEoln();
    for (int room = 0; room < roomsTotal; room++) {
        int roomSize = room % 2 == 0 ? 3 : 2;
        if (roomsBoys[room] + roomsGirls[room] > roomSize) {
            quitf(_wa,
                  "room #%d has size %d, but there is %d people",
                  room + 1,
                  roomSize,
                  roomsBoys[room] + roomsGirls[room]);
        }
        if (roomsBoys[room] != 0 && roomsGirls[room] != 0) {
            quitf(_wa,
                  "boys and girls together in room #%d",
                  room + 1);
        }
    }
    quit(_ok, "settlement are correct");
}