#include <iostream>
#include <vector>

using namespace std;


void printSolution(vector<int> const &boysPlaces, vector<int> const &girlsPlaces) {
    cout << "Yes\n";
    for (int place : boysPlaces) {
        cout << place + 1 << ' ';
    }
    cout << '\n';
    for (int place : girlsPlaces) {
        cout << place + 1 << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int blocks;
    int boys, girls;
    cin >> blocks >> boys >> girls;

    if (boys + girls == blocks * 5 && (girls == 1 || boys == 1)) {
        cout << "No\n";
        return 0;
    }

    int remainGirls = girls % 5;
    int remainBoys = boys % 5;
    bool swapped = false;
    if (remainBoys > remainGirls) {
        swap(boys, girls);
        swap(remainBoys, remainGirls);
        swapped = true;
    }

    int room = 0;
    int lastRoomCount = 0;
    auto updateRoom = [&room, &lastRoomCount]() {
        lastRoomCount++;
        if ((room % 2 == 0 && lastRoomCount == 3) ||
            (room % 2 == 1 && lastRoomCount == 2)) {
            room++;
            lastRoomCount = 0;
        }
    };

    int remainBlocks = blocks - girls / 5 - boys / 5;
    bool conflict = remainBoys == 1 && remainGirls == 4 && remainBlocks == 1;

    vector<int> boysPlaces(boys);
    vector<int> girlsPlaces(girls);
    remainGirls = conflict ? remainGirls : 0;
    remainBoys = conflict ? remainBoys + 2 : 0;
    for (int i = remainGirls; i < girls; i++) {
        girlsPlaces[i] = room;
        updateRoom();
    }
    if (lastRoomCount != 0) {
        room++;
        lastRoomCount = 0;
    }
    for (int i = remainBoys; i < boys; i++) {
        boysPlaces[i] = room;
        updateRoom();
    }

    if (conflict) {
        int girlRoom1 = blocks * 2 - 1;
        int girlRoom2 = blocks * 2 - 3;
        int boyRoom = blocks * 2 - 2;
        boysPlaces[0] = boyRoom;
        boysPlaces[1] = boyRoom;
        boysPlaces[2] = boyRoom;
        girlsPlaces[0] = girlRoom1;
        girlsPlaces[1] = girlRoom1;
        girlsPlaces[2] = girlRoom2;
        girlsPlaces[3] = girlRoom2;
    }

    if (swapped) {
        swap(boysPlaces, girlsPlaces);
    }
    printSolution(boysPlaces, girlsPlaces);
}