//find good parts
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1000;
vector<int> a[MAXN];
vector<int> b[MAXN];

vector<int> dx = {0, 1, 0, -1};
vector<int> dy = {1, 0, -1, 0};

using Figure = set<pair<int, int>>;

vector<set<Figure>> figures;

int n;
int m;

bool inField(int x, int y)
{
	return (x >= 0 && x < n && y >= 0 && y < m);
}

Figure create(int i, int j, int p)
{
	Figure result;
	queue<pair<int, int>> q;
	q.push({i, j});
	result.insert({0, 0});
	while (!q.empty())
	{
		auto [curi, curj] = q.front();
		q.pop();
		for (int v = 0; v < 4; v++)
		{
			int newi = curi + dx[v];
			int newj = curj + dy[v];
			if (inField(newi, newj) && !result.count({newi - i, newj - j}) && (a[newi][newj] == p))
			{
				q.push({newi, newj});
				result.insert({newi - i, newj - j});
			}
		}
	}
	//cerr << result.size() << endl;
	return result;
}

bool compare(Figure a, Figure b)
{
	assert(a.size() == b.size());
	b.merge(a);
	return a.size() == b.size();
}

bool compare(int x, int y)
{
	for (auto& a : figures[x])
	{
		for (auto& b : figures[y])
		{
			if (compare(a, b)) return true;
		}
	}
	return false;
}

void rotate()
{
	for (int i = 0; i < m; i++)
	{
		b[i].assign(n, 0);
		for (int j = 0; j < n; j++)
		{
			b[i][j] = a[j][m - 1 - i];
		}
	}
	
	for (int i = 0; i < m; i++)
	{
		a[i].assign(n, 0);
		for (int j = 0; j < n; j++)
		{
			a[i][j] = b[i][j];
		}
	}
	
	swap(n, m);
}

int main()
{

	cin >> n >> m;
	int cnt = 0;
	for (int i = 0; i < n; i++)
	{
		a[i].resize(m);
		for (int j = 0; j < m; j++)
		{
			cin >> a[i][j];
			cnt = max(cnt, a[i][j]);
		}
	}
	
	figures.resize(cnt + 1);
	
	for (int r = 0; r < 4; r++) {		
		for (int q = 1; q <= cnt; q++)
		{
			bool f = false;
			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < m; j++)
				{
					if (a[i][j] == q)
					{
						figures[q].insert(create(i, j, q));
						f = true;
						break;
					}
				}
				if (f) break;
			}
		}
		rotate();
	}
	
	for (int p = 1; p <= cnt; p++)
	{
		for (int q = p + 1; q <= cnt; q++)
		{
			if (compare(p, q)) cerr << p << " " << q << endl;
		}
	}
}	